@read_ncdf.pro

PRO VSaber_Empty, event


END ;---------------------------------------------------------------------------


PRO VSaber_Quit, event

  Widget_Control, event.top, /Destroy
END ;---------------------------------------------------------------------------


PRO VSaber_Plot, event

   ; Get the info structure and copy it here.

Widget_Control, event.top, Get_UValue=info, /No_Copy


    IAA_Plot, Group_leader=event.top

   ; Put the info structure back in its storage location.

Widget_Control, event.top, Set_UValue=info, /No_Copy
END ;---------------------------------------------------------------------------


PRO VSaber_kTempMean, event

   ; Get the info structure and copy it here.

Widget_Control, event.top, Get_UValue=info, /No_Copy

IAA_Contour, (*info.data).ktemp, (*info.data).tplatitude, (*info.data).tpaltitude, fill=1, $
         title='Zonal Mean!CTemperature K', min_value=0, Group_leader=event.top, $
         functionality='vsaber_ktemp'

   ; Put the info structure back in its storage location.

Widget_Control, event.top, Set_UValue=info, /No_Copy
END ;---------------------------------------------------------------------------

PRO VSaber_pressureMean, event

   ; Get the info structure and copy it here.

Widget_Control, event.top, Get_UValue=info, /No_Copy

IAA_Contour, (*info.data).pressure, (*info.data).tplatitude, (*info.data).tpaltitude, cb_log=1, fill=1, $
         title='Zonal Mean!CPressure mbar', min_value=0, invertcolors=1, barformat='(E20.2)', Group_leader=event.top, $
         functionality='vsaber_pressure'

   ; Put the info structure back in its storage location.

Widget_Control, event.top, Set_UValue=info, /No_Copy
END ;---------------------------------------------------------------------------

PRO VSaber_O3_96Mean, event

   ; Get the info structure and copy it here.

Widget_Control, event.top, Get_UValue=info, /No_Copy

IAA_Contour, (*info.data).O3_96, (*info.data).tplatitude, (*info.data).tpaltitude, cb_log=1, fill=1, $
         title='Zonal Mean!CO3 Mixing Ratio 9.6 m', min_value=0, invertcolors=1, barformat='(E20.2)', Group_leader=event.top, $
         functionality='vsaber_O3_96'

   ; Put the info structure back in its storage location.

Widget_Control, event.top, Set_UValue=info, /No_Copy
END ;---------------------------------------------------------------------------

PRO VSaber_O3_127Mean, event

   ; Get the info structure and copy it here.

Widget_Control, event.top, Get_UValue=info, /No_Copy

IAA_Contour, (*info.data).O3_127, (*info.data).tplatitude, (*info.data).tpaltitude, cb_log=1, fill=1, $
         title='Zonal Mean!CO3 Mixing Ratio 1.27 m', min_value=0, invertcolors=1, barformat='(E20.2)', max_value=1, $
         functionality='vsaber_O3_127', Group_leader=event.top

   ; Put the info structure back in its storage location.

Widget_Control, event.top, Set_UValue=info, /No_Copy
END ;---------------------------------------------------------------------------

PRO VSaber_CO2Mean, event

   ; Get the info structure and copy it here.

Widget_Control, event.top, Get_UValue=info, /No_Copy

IAA_Contour, (*info.data).CO2, (*info.data).tplatitude, (*info.data).tpaltitude, fill=1, $
         title='Zonal Mean!CCO2 Mixing Ratio', min_value=0, invertcolors=1, barformat='(E20.2)', Group_leader=event.top, $
         functionality='vsaber_CO2'

   ; Put the info structure back in its storage location.

Widget_Control, event.top, Set_UValue=info, /No_Copy
END ;---------------------------------------------------------------------------

PRO VSaber_OMean, event

   ; Get the info structure and copy it here.

Widget_Control, event.top, Get_UValue=info, /No_Copy

IAA_Contour, (*info.data).O, (*info.data).tplatitude, (*info.data).tpaltitude, cb_log=1, fill=1, $
         title='Zonal Mean!CO Mixing Ratio', min_value=0, barformat='(E20.2)', Group_leader=event.top, $
         functionality='vsaber_O'

   ; Put the info structure back in its storage location.

Widget_Control, event.top, Set_UValue=info, /No_Copy
END ;---------------------------------------------------------------------------

PRO VSaber_HMean, event

   ; Get the info structure and copy it here.

Widget_Control, event.top, Get_UValue=info, /No_Copy

IAA_Contour, (*info.data).H, (*info.data).tplatitude, (*info.data).tpaltitude, cb_log=1, fill=1, $
         title='Zonal Mean!CH Mixing Ratio', min_value=0, barformat='(E20.2)', Group_leader=event.top, $
         functionality='vsaber_H'

   ; Put the info structure back in its storage location.

Widget_Control, event.top, Set_UValue=info, /No_Copy
END ;---------------------------------------------------------------------------

PRO VSaber_about, event

value = [$
'', $
'VSaber Version 1.0', $
'', $
'Jos Enrique Ruiz', $
'Dept. del Sistema Solar', $
'Instituto Astrofsica de Andaluca', $
'CSIC', $
'' $
]

about = DIALOG_MESSAGE(value, /information)
END ;---------------------------------------------------------------------------

PRO VSaber_Cleanup, tlb

Widget_Control, tlb, Get_UValue=info, /No_Copy

IF N_Elements(info) EQ 0 THEN RETURN

; Clean pointers
Ptr_Free, info.data
Ptr_Free, info.filesptr

END ;---------------------------------------------------------------------------

PRO VSaber_Multiple, event

   ; Get the info structure and copy it here.

Widget_Control, event.top, Get_UValue=info, /No_Copy

Catch, theError
IF theError NE 0 THEN BEGIN
   Catch, /Cancel
   ok = Error_Message(Traceback=1)
   RETURN
ENDIF

files = DIALOG_PICKFILE(Get_Path=thePath, /READ, /MULTIPLE_FILES)

IF FILES[0] NE '' THEN BEGIN


   ; Clear From / To
   WIDGET_CONTROL, info.toID, Set_Value='To : '
   WIDGET_CONTROL, info.fromID, Set_Value='From : '

   info.fromfolder=''
   info.tofolder=''
   info.filesptr=Ptr_New(files)


   FOR i=0, N_Elements(files)-1 DO BEGIN
   shortname = StrMid(files[i], StrLen(thePath))
   files[i] = shortname
   ENDFOR

   ; Modify table
   WIDGET_CONTROL, info.filestoreadID, Set_Value=files
   WIDGET_CONTROL, info.readID, SENSITIVE=1


   WIDGET_CONTROL, info.daysID, Set_Value='# Days : '
   WIDGET_CONTROL, info.orbitsID, Set_Value='# Orbits : '
   WIDGET_CONTROL, info.scansID, Set_Value='# Scans : '
   WIDGET_CONTROL, info.shotsID, Set_Value='# Shots : '

   WIDGET_CONTROL, info.daysID, SENSITIVE=0
   WIDGET_CONTROL, info.orbitsID, SENSITIVE=0
   WIDGET_CONTROL, info.scansID, SENSITIVE=0
   WIDGET_CONTROL, info.shotsID, SENSITIVE=0

ENDIF

   ; Put the info structure back in its storage location.

Widget_Control, event.top, Set_UValue=info, /No_Copy
END ;---------------------------------------------------------------------------

PRO VSaber_OpenFile, event

   ; Get the info structure and copy it here.

Widget_Control, event.top, Get_UValue=info, /No_Copy

Catch, theError
IF theError NE 0 THEN BEGIN
   Catch, /Cancel
   ok = Error_Message(Traceback=1)
   RETURN
ENDIF

;folder = DIALOG_PICKFILE(PATH='D:\RSI\IDL61\SABER\Level2A\2005\028', /DIRECTORY)
folder = DIALOG_PICKFILE(/DIRECTORY)


IF folder[0] NE '' THEN BEGIN

    ; Any files in this folder ?

    result = FILE_SEARCH(folder+'*.nc', count=nbncfiles)

    IF nbncfiles EQ 0 THEN BEGIN
        alert = DIALOG_MESSAGE('No files in this folder', /information)
        Widget_Control, event.top, Set_UValue=info, /No_Copy
        RETURN
    ENDIF


    Labelref=STRMID(folder,8,10, /REVERSE_OFFSET)
    Widget_Control, event.id, Get_UValue=direction

     ; From folders

    IF direction EQ 'from' THEN BEGIN

        info.fromfolder=folder
        Widget_Control, info.fromID, Set_Value='From : '+Labelref
        YearFrom = STRMID(Labelref, 0, 4)
        DayFrom = STRMID(Labelref, 5, 3)

        IF info.tofolder EQ '' THEN BEGIN
            info.tofolder=folder
            Widget_Control, info.toID, Set_Value='To : '+Labelref
            YearTo = STRMID(Labelref, 0, 4)
            DayTo = STRMID(Labelref, 5, 3)
        ENDIF ELSE BEGIN
            Labelref=strmid(info.tofolder,8,10, /REVERSE_OFFSET)
            YearTo = STRMID(Labelref, 0, 4)
            DayTo = STRMID(Labelref, 5, 3)
        ENDELSE


    ENDIF

     ; To folders

    IF direction EQ 'to' THEN BEGIN

        info.tofolder=folder
        Widget_Control, info.toID, Set_Value='To : '+Labelref
        YearTo = STRMID(Labelref, 0, 4)
        DayTo = STRMID(Labelref, 5, 3)

        IF info.fromfolder EQ '' THEN BEGIN
            info.fromfolder=folder
            Widget_Control, info.fromID, Set_Value='From : '+Labelref
            YearFrom = STRMID(Labelref, 0, 4)
            DayFrom = STRMID(Labelref, 5, 3)
        ENDIF ELSE BEGIN
            Labelref=STRMID(info.fromfolder,8,10, /REVERSE_OFFSET)
            YearFrom = STRMID(Labelref, 0, 4)
            DayFrom = STRMID(Labelref, 5, 3)
        ENDELSE

    ENDIF

    dateFrom = Long(YearFrom+DayFrom)
    dateTo = Long(YearTo+DayTo)

    ; Wrong Order in Dates ?

    IF dateTo LT dateFrom THEN BEGIN
       alert = DIALOG_MESSAGE('Wrong order in dates selection.', /information)
       IF direction EQ 'to' THEN BEGIN
         info.tofolder=info.fromfolder
         Labelref=strmid(info.tofolder,8,10, /REVERSE_OFFSET)
         Widget_Control, info.toID, Set_Value='To : '+Labelref
       ENDIF ELSE BEGIN
         info.fromfolder=info.tofolder
         Labelref=strmid(info.fromfolder,8,10, /REVERSE_OFFSET)
         Widget_Control, info.fromID, Set_Value='From : '+Labelref
       ENDELSE
        Widget_Control, event.top, Set_UValue=info, /No_Copy
        RETURN
    ENDIF

    WIDGET_CONTROL, info.filestoreadID, Set_Value=''
    WIDGET_CONTROL, info.readID, SENSITIVE=1

    WIDGET_CONTROL, info.daysID, Set_Value='# Days : '
    WIDGET_CONTROL, info.orbitsID, Set_Value='# Orbits : '
    WIDGET_CONTROL, info.scansID, Set_Value='# Scans : '
    WIDGET_CONTROL, info.shotsID, Set_Value='# Shots : '

    WIDGET_CONTROL, info.daysID, SENSITIVE=0
    WIDGET_CONTROL, info.orbitsID, SENSITIVE=0
    WIDGET_CONTROL, info.scansID, SENSITIVE=0
    WIDGET_CONTROL, info.shotsID, SENSITIVE=0

ENDIF

   ; Put the info structure back in its storage location.

Widget_Control, event.top, Set_UValue=info, /No_Copy
END ;---------------------------------------------------------------------------


PRO VSaber_ReadFiles, event

   ; Get the info structure and copy it here.

Widget_Control, event.top, Get_UValue=info, /No_Copy

Catch, theError
IF theError NE 0 THEN BEGIN
   Catch, /Cancel
   ok = Error_Message(Traceback=1)
   RETURN
ENDIF

    ; Initialazing parameters
nbdays = 0
nborbits = 0
nbscans = 0
nbshots = 0

     ; Sensitizing menus and labels

WIDGET_CONTROL, info.orbitsID, SENSITIVE=1
WIDGET_CONTROL, info.scansID, SENSITIVE=1
WIDGET_CONTROL, info.shotsID, SENSITIVE=1

     ; Fetching Grids Values

WIDGET_CONTROL, info.latitudefromID, GET_VALUE=latitudefrom
WIDGET_CONTROL, info.latitudetoID, GET_VALUE=latitudeto
WIDGET_CONTROL, info.stepslatID, GET_VALUE=steplat
WIDGET_CONTROL, info.altitudefromID, GET_VALUE=altitudefrom
WIDGET_CONTROL, info.altitudetoID, GET_VALUE=altitudeto
WIDGET_CONTROL, info.stepsaltID, GET_VALUE=stepalt

currentIndex = Widget_Info(info.daynightID, /DropList_Select)
WIDGET_CONTROL, info.daynightID, GET_UVALUE=daynightArr
daynightval = daynightArr[currentIndex]

      ; Control grids inputs

IF (latitudefrom LT -90 OR latitudefrom GE latitudeto) THEN BEGIN
    latitudefrom=-90
    WIDGET_CONTROL, info.latitudefromID, SET_VALUE=latitudefrom
ENDIF

IF (latitudeto GT 90 OR latitudeto LE latitudefrom) THEN BEGIN
    latitudeto=90
    WIDGET_CONTROL, info.latitudetoID, SET_VALUE=latitudeto
ENDIF

IF (altitudefrom LT 0 OR altitudefrom GE altitudeto) THEN BEGIN
    altitudefrom=0
    WIDGET_CONTROL, info.altitudefromID, SET_VALUE=altitudefrom
ENDIF

IF (altitudeto LT 0 OR altitudeto LE altitudefrom) THEN BEGIN
    altitudeto=150
    WIDGET_CONTROL, info.altitudetoID, SET_VALUE=altitudeto
ENDIF

IF (stepalt LT 0 ) THEN BEGIN
    stepalt=75
    WIDGET_CONTROL, info.stepsaltID, SET_VALUE=stepalt
ENDIF

IF (steplat LT 0 ) THEN BEGIN
    steplat=75
    WIDGET_CONTROL, info.stepslatID, SET_VALUE=steplat
ENDIF


     ; Grid altitude

nbgridsZ = stepalt ; resolution in altitude
dz=(altitudeto - altitudefrom)*1./nbgridsZ
ZArr = FltArr(nbgridsZ)
FOR i=0L,nbgridsZ-1 DO BEGIN
  ZArr[i] = altitudeto - i*dz
ENDFOR

     ; Grid latitude

nbgridsLat = steplat ; resolution in latitude
dlat=(latitudeto - latitudefrom)*1./nbgridsLat
LatArr = FltArr(nbgridsLat)
FOR i=0L,nbgridsLat-1 DO BEGIN
  latArr[i] = latitudefrom + i*dlat
ENDFOR

     ; Fetching files in folders

IF info.fromfolder NE '' AND info.tofolder NE '' THEN BEGIN

    WIDGET_CONTROL, info.daysID, SENSITIVE=1

    lenfolder = STRLEN(info.fromfolder)-9
    BaseFolder = STRMID(info.fromfolder, 0, lenfolder)
    Separator = STRMID(info.fromfolder, 0, 1, /REVERSE_OFFSET)
    Labelref= STRMID(info.fromfolder,8,10, /REVERSE_OFFSET)
    YearFrom = STRMID(Labelref, 0, 4)
    DayFrom = STRMID(Labelref, 5, 3)
    Labelref= STRMID(info.tofolder,8,10, /REVERSE_OFFSET)
    YearTo = STRMID(Labelref, 0, 4)
    DayTo = STRMID(Labelref, 5, 3)

    ; Loop in years
    FOR iYear=Long(YearFrom), Long(YearTo) DO BEGIN

        dirYear = String(iYear, Format="(I4)")
        IF FILE_TEST(BaseFolder+dirYear, /DIRECTORY) THEN BEGIN

           IF dirYear EQ YearFrom THEN BEGIN
           dayBegin=dayFrom
           ENDIF ELSE dayBegin='001'

           IF dirYear EQ YearTo THEN BEGIN
           dayEnd=dayTo
           ENDIF ELSE dayEnd='366'

           ; Loop in days
           FOR iDay=Long(dayBegin), Long(dayEnd) DO BEGIN

             dirDay = strcompress(string(iday),/remove_all)
             IF (iDay LE 9) THEN dirDay = '00'+dirDay
             IF (iDay GT 9 AND iDay LE 99) THEN dirDay = '0'+dirDay

             IF FILE_TEST(BaseFolder+dirYear+Separator+dirDay, /DIRECTORY) THEN BEGIN

             dirfile = BaseFolder+dirYear+Separator+dirDay+Separator
             filesread = FILE_SEARCH(dirfile+'*.nc', /FULLY_QUALIFY_PATH)

             nbdays = nbdays+1
             Widget_Control, info.daysID, Set_Value='# Days : '+strcompress(string(nbdays),/remove_all)

             IF N_Elements(files) EQ 0 THEN files=filesread ELSE files=[files,filesread]

             ENDIF

           ENDFOR
           ; End Loop in days

        ENDIF

    ENDFOR
    ; End Loop in years

info.filesptr=Ptr_New(files)

ENDIF


     ; Only take these variables, speed process

list = ['tpaltitude', 'tplatitude', 'pressure', 'ktemp', 'O3_96', 'O3_127', 'CO2', 'O', 'H', 'tpDN']

ktempMean = FltArr(nbgridsLat, nbgridsZ)
pressureMean = FltArr(nbgridsLat, nbgridsZ)
O3_96Mean = FltArr(nbgridsLat, nbgridsZ)
O3_127Mean = FltArr(nbgridsLat, nbgridsZ)
CO2Mean = FltArr(nbgridsLat, nbgridsZ)
OMean = FltArr(nbgridsLat, nbgridsZ)
HMean = FltArr(nbgridsLat, nbgridsZ)

ktempCount = LonArr(nbgridsLat)
pressureCount = LonArr(nbgridsLat)
O3_96Count = LonArr(nbgridsLat)
O3_127Count = LonArr(nbgridsLat)
CO2Count = LonArr(nbgridsLat)
OCount = LonArr(nbgridsLat)
HCount = LonArr(nbgridsLat)

ncfiles = *info.filesptr



 ; Loop in orbits/files
 FOR ifile=0L,N_Elements(ncfiles)-1 DO BEGIN

     nborbits = nborbits+1
     Widget_Control, info.orbitsID, Set_Value='# Orbits : '+strcompress(string(nborbits),/remove_all)
     Widget_Control, info.messageID, Set_Value='Reading '+ncfiles[ifile]

     ; Read file
     r = read_ncdf(ncfiles[ifile], strdata, variable_list=list, /quiet)


     ; Loop in scans
     FOR iscan=0L,strdata.event-1 DO BEGIN

     IF daynightval EQ 0 OR (strdata.tpDN[iscan] EQ daynightval-1) THEN BEGIN

         nbscans = nbscans+1
         Widget_Control, info.scansID, Set_Value='# Scans : '+strcompress(string(nbscans),/remove_all)

         ; **********************************************************************
         ;
         ; 400 shots for each scan
         ; 75 scans for each orbit
         ; 15 orbits for each day
         ; 400 x 75 = 30 000 shots for each orbit
         ; 30 000 x 15 = 450 000 shots for each day
         ; 450 000 x 365 = 165 millions of shots in one year
         ;
         ; **********************************************************************

         ; Fill arrays
IF iscan LT 1 THEN help, strdata.ktemp

           ; Handling missing data
           KteSelected = WHERE(strdata.ktemp[*,iscan] GT 0)
           PreSelected = WHERE(strdata.pressure[*,iscan] GT 0)
           O3_96Selected = WHERE(strdata.O3_96[*,iscan] GT 0)
           O3_127Selected = WHERE(strdata.O3_127[*,iscan] GT 0)
           CO2Selected = WHERE(strdata.CO2[*,iscan] GT 0)
           OSelected = WHERE(strdata.O[*,iscan] GT 0)
           HSelected = WHERE(strdata.H[*,iscan] GT 0)

           ; Mean Latitudes
           ktempLatMean = 0
           IF N_Elements(KteSelected) GT 1 THEN $
           ktempLatMean = Total(strdata.tplatitude[KteSelected,iscan])/N_Elements(KteSelected)
           pressureLatMean = 0
           IF N_Elements(PreSelected) GT 1 THEN $
           pressureLatMean = Total(strdata.tplatitude[PreSelected,iscan])/N_Elements(PreSelected)
           O3_96LatMean = 0
           IF N_Elements(O3_96Selected) GT 1 THEN $
           O3_96LatMean = Total(strdata.tplatitude[O3_96Selected,iscan])/N_Elements(O3_96Selected)
           O3_127LatMean = 0
           IF N_Elements(O3_127Selected) GT 1 THEN $
           O3_127LatMean = Total(strdata.tplatitude[O3_127Selected,iscan])/N_Elements(O3_127Selected)
           CO2LatMean = 0
           IF N_Elements(CO2Selected) GT 1 THEN $
           CO2LatMean = Total(strdata.tplatitude[CO2Selected,iscan])/N_Elements(CO2Selected)
           OLatMean = 0
           IF N_Elements(OSelected) GT 1 THEN $
           OLatMean = Total(strdata.tplatitude[OSelected,iscan])/N_Elements(OSelected)
           HLatMean = 0
           IF N_Elements(HSelected) GT 1 THEN $
           HLatMean = Total(strdata.tplatitude[HSelected,iscan])/N_Elements(HSelected)

           ; Fill Means
           IF VALUE_LOCATE(LatArr, ktempLatMean) NE -1 AND N_Elements(KteSelected) GT 1 THEN  BEGIN
               loc = VALUE_LOCATE(LatArr, ktempLatMean)
               ktempCount[loc] = ktempCount[loc]+1
               ktempInter = interpol(strdata.ktemp[KteSelected,iscan], strdata.tpaltitude[KteSelected,iscan], ZArr)
               ktempMean[loc, *] = ktempMean[loc, *] + ktempInter
           ENDIF

           IF VALUE_LOCATE(LatArr, pressureLatMean) NE -1 AND N_Elements(PreSelected) GT 1 THEN  BEGIN
               loc = VALUE_LOCATE(LatArr, pressureLatMean)
               pressureCount[loc] = pressureCount[loc]+1
               pressureInter = interpol(strdata.pressure[PreSelected,iscan], strdata.tpaltitude[PreSelected,iscan], ZArr)
               pressureMean[loc, *] = pressureMean[loc, *] + pressureInter
           ENDIF

           IF VALUE_LOCATE(LatArr, O3_96LatMean) NE -1 AND N_Elements(O3_96Selected) GT 1 THEN  BEGIN
               loc = VALUE_LOCATE(LatArr, O3_96LatMean)
               O3_96Count[loc] = O3_96Count[loc]+1
               O3_96Inter = interpol(strdata.O3_96[O3_96Selected,iscan], strdata.tpaltitude[O3_96Selected,iscan], ZArr)
               O3_96Mean[loc, *] = O3_96Mean[loc, *] + O3_96Inter
           ENDIF
           IF VALUE_LOCATE(LatArr, O3_127LatMean) NE -1 AND N_Elements(O3_127Selected) GT 1 THEN  BEGIN
               loc = VALUE_LOCATE(LatArr, O3_127LatMean)
               O3_127Count[loc] = O3_127Count[loc]+1
               O3_127Inter = interpol(strdata.O3_127[O3_127Selected,iscan], strdata.tpaltitude[O3_127Selected,iscan], ZArr)
               O3_127Mean[loc, *] = O3_127Mean[loc, *] + O3_127Inter
           ENDIF
           IF VALUE_LOCATE(LatArr, CO2LatMean) NE -1 AND N_Elements(CO2Selected) GT 1 THEN  BEGIN
               loc = VALUE_LOCATE(LatArr, CO2LatMean)
               CO2Count[loc] = CO2Count[loc]+1
               CO2Inter = interpol(strdata.CO2[CO2Selected,iscan], strdata.tpaltitude[CO2Selected,iscan], ZArr)
               CO2Mean[loc, *] = CO2Mean[loc, *] + CO2Inter
           ENDIF
           IF VALUE_LOCATE(LatArr, HLatMean) NE -1 AND N_Elements(HSelected) GT 1 THEN  BEGIN
               loc = VALUE_LOCATE(LatArr, HLatMean)
               HCount[loc] = HCount[loc]+1
               HInter = interpol(strdata.H[HSelected,iscan], strdata.tpaltitude[HSelected,iscan], ZArr)
               HMean[loc, *] = HMean[loc, *] + HInter
           ENDIF
           IF VALUE_LOCATE(LatArr, OLatMean) NE -1 AND N_Elements(OSelected) GT 1 THEN  BEGIN
               loc = VALUE_LOCATE(LatArr, OLatMean)
               OCount[loc] = OCount[loc]+1
               OInter = interpol(strdata.O[OSelected,iscan], strdata.tpaltitude[OSelected,iscan], ZArr)
               OMean[loc, *] = OMean[loc, *] + OInter
           ENDIF
           nbshots = nbshots+N_Elements(strdata.tplatitude[*,iscan])
           Widget_Control, info.shotsID, Set_Value='# Shots : '+strcompress(string(nbshots),/remove_all)

     ENDIF

     ENDFOR
    ; End Loop in scans


 ENDFOR
 ; End Loop in orbits


; Calculates Means for each point in grid latitude
FOR i=0L,nbgridsLat-1 DO BEGIN
    IF ktempCount[i] GT 0 THEN ktempMean[i, *]=ktempMean[i, *]/ktempCount[i]
    IF pressureCount[i] GT 0 THEN pressureMean[i, *]=pressureMean[i, *]/pressureCount[i]
    IF O3_96Count[i] GT 0 THEN O3_96Mean[i, *]=O3_96Mean[i, *]/O3_96Count[i]
    IF O3_127Count[i] GT 0 THEN O3_127Mean[i, *]=O3_127Mean[i, *]/O3_127Count[i]
    IF CO2Count[i] GT 0 THEN CO2Mean[i, *]=CO2Mean[i, *]/CO2Count[i]
    IF OCount[i] GT 0 THEN OMean[i, *]=OMean[i, *]/OCount[i]
    IF HCount[i] GT 0 THEN HMean[i, *]=HMean[i, *]/HCount[i]
ENDFOR


strtodata = {tplatitude:LatArr, $
           tpaltitude:ZArr, $
           pressure:pressureMean, $
           ktemp:ktempMean, $
           O3_96:O3_96Mean, $
           O3_127:O3_127Mean, $
           CO2:CO2Mean, $
           O:OMean, $
           H:HMean}

info.data = Ptr_New(strtodata)

WIDGET_CONTROL, info.messageID, Set_Value=''
;WIDGET_CONTROL, info.plotsID, SENSITIVE=1
WIDGET_CONTROL, info.contoursID, SENSITIVE=1

   ; Put the info structure back in its storage location.

Widget_Control, event.top, Set_UValue=info, /No_Copy
END ;---------------------------------------------------------------------------

PRO VSaber

   ; Catch any error in the VSaber program.

Catch, theError
IF theError NE 0 THEN BEGIN
   Catch, /Cancel
   ok = Error_Message(Traceback=1)
   RETURN
ENDIF

IF XRegistered('vSaber') GT 0 THEN BEGIN
  ok = Dialog_Message('Only one VSaber can be used at once.')
  RETURN
ENDIF

   ; Define the TLB.

tlb = Widget_Base(Column=1, /tlb_frame_attr, Title='VSaber 1.0', MBar=menubarID)

   ; Define the File pull-down menu.

filesID = Widget_Button(menubarID, Value='Files')
multipleID = Widget_Button(filesID, Value='Open...', Event_Pro='VSaber_Multiple')
quitID = Widget_Button(filesID, Value='Quit', Event_Pro='VSaber_Quit')

   ; Define the 1D pull-down menu.

plotsID = Widget_Button(menubarID, Value='1D Plots', SENSITIVE=0)
button = Widget_Button(plotsID, Value='Example 1', Event_Pro='VSaber_Plot')
button = Widget_Button(plotsID, Value='Example 2', Event_Pro='VSaber_Plot')
button = Widget_Button(plotsID, Value='Example 3', Event_Pro='VSaber_Plot')

   ; Define the 2D pull-down menu.

contoursID = Widget_Button(menubarID, Value='2D Contour', SENSITIVE=0)
button = Widget_Button(contoursID, Value='Temperature', Event_Pro='VSaber_ktempMean')
button = Widget_Button(contoursID, Value='Pressure', Event_Pro='VSaber_pressureMean')
button = Widget_Button(contoursID, Value='CO2', Event_Pro='VSaber_CO2Mean')
button = Widget_Button(contoursID, Value='O3_96', Event_Pro='VSaber_O3_96Mean')
button = Widget_Button(contoursID, Value='O3_127', Event_Pro='VSaber_O3_127Mean')
button = Widget_Button(contoursID, Value='O', Event_Pro='VSaber_OMean')
button = Widget_Button(contoursID, Value='H', Event_Pro='VSaber_HMean')

   ; Define the Help pull-down menu.

HelpID = Widget_Button(menubarID, Value='Help')
button = Widget_Button(HelpID, Value='About...', Event_Pro='VSaber_About')

   ; Define Files label widgets.

space = CW_Spacer(tlb)
filestlb = Widget_Base(tlb, Row=1)
space = CW_Spacer(filestlb)
filestoreadID = Widget_Droplist(filestlb, VALUE='', title='File(s) to read :', /DYNAMIC_RESIZE, Event_Pro='VSaber_Empty')
space = CW_Spacer(filestlb)
space = CW_Spacer(filestlb)
daynightArr = ['All', 'Day', 'Night']
daynightVal = [0, 1, 2]
daynightID = Widget_Droplist(filestlb, VALUE=daynightArr, title='Day/Night :', /DYNAMIC_RESIZE, Event_Pro='VSaber_Empty', Uvalue=daynightVal)
space = CW_Spacer(filestlb)

    ; Define fromto label widgets.

fromtotlb = Widget_Base(tlb, Row=1)

space = CW_Spacer(fromtotlb)
fromtlb = Widget_Base(fromtotlb, Column=1, XSIZE=100, UNITS=0)
    fromID = Widget_label(fromtlb, Value='From :',  /DYNAMIC_RESIZE, /ALIGN_LEFT)
    openID = Widget_Button(fromtlb, Value='Browse...', UValue='from', Event_Pro='VSaber_OpenFile')
space = CW_Spacer(fromtotlb)

space = CW_Spacer(fromtotlb)
totlb = Widget_Base(fromtotlb, Column=1, XSIZE=100, UNITS=0)
    toID = Widget_label(totlb, Value='To :', /DYNAMIC_RESIZE, /ALIGN_LEFT)
    openID = Widget_Button(totlb, Value='Browse...', UValue='to', Event_Pro='VSaber_OpenFile')

   ; Define interpol label.

interpoltlb = Widget_Base(tlb, Row=1)
space = CW_Spacer(interpoltlb)
LABEL = Widget_label(interpoltlb, Value='INTERPOL GRID',  /ALIGN_LEFT)
space = CW_Spacer(interpoltlb)

   ; Define rang labels widgets.

latitudetlb = Widget_Base(tlb, Row=1)
space = CW_Spacer(latitudetlb)
latitudefromID = CW_Field(latitudetlb, Value='-90', Title='Latitude :', XSIZE=5, /INTEGER)
latitudetoID = CW_Field(latitudetlb, Value='90', Title='-  ', XSIZE=5, /INTEGER)
stepslatID = CW_Field(latitudetlb, Value='75', Title='# Steps :', XSIZE=5, /INTEGER)

altitudetlb = Widget_Base(tlb, Row=1)
space = CW_Spacer(altitudetlb)
altitudefromID = CW_Field(altitudetlb, Value='0', Title='Altitude : ', XSIZE=5, /INTEGER)
altitudetoID = CW_Field(altitudetlb, Value='150', Title='-  ', XSIZE=5, /INTEGER)
stepsaltID = CW_Field(altitudetlb, Value='75', Title='# Steps :', XSIZE=5, /INTEGER)


   ; Define read files button widget.

readfilestlb = Widget_Base(tlb, Row=1)

space = CW_Spacer(readfilestlb)
buttontlb = Widget_Base(readfilestlb, Column=1)
    readID = Widget_Button(buttontlb, Value='Read all files', Event_Pro='VSaber_ReadFiles', SENSITIVE=0)


   ; Define label widgets.

daystlb = Widget_Base(tlb, Row=1)
space = CW_Spacer(daystlb)
daysID = Widget_label(daystlb, Value='# Days :', SENSITIVE=0, /DYNAMIC_RESIZE)
space = CW_Spacer(fromtotlb)

orbitstlb = Widget_Base(tlb, Row=1)
space = CW_Spacer(orbitstlb)
orbitsID = Widget_label(orbitstlb, Value='# Orbits :', SENSITIVE=0, /DYNAMIC_RESIZE)
space = CW_Spacer(fromtotlb)

scanstlb = Widget_Base(tlb, Row=1)
space = CW_Spacer(scanstlb)
scansID = Widget_label(scanstlb, Value='# Scans :', SENSITIVE=0, /DYNAMIC_RESIZE)
space = CW_Spacer(fromtotlb)

shotstlb = Widget_Base(tlb, Row=1)
space = CW_Spacer(shotstlb)
shotsID = Widget_label(shotstlb, Value='# Shots :', SENSITIVE=0, /DYNAMIC_RESIZE)
space = CW_Spacer(shotstlb)


messagetlb = Widget_Base(tlb, Row=1, /ALIGN_CENTER)
space = CW_Spacer(messagetlb)
messageID = Widget_label(messagetlb, Value='', /DYNAMIC_RESIZE, /ALIGN_CENTER)
space = CW_Spacer(messagetlb)


   ; Realize the widget hierarchy.

Widget_Control, tlb, /Realize

   ; Create the info structure with the information
   ; required to run the program.


info = {plotsID:plotsID, $
       contoursID:contoursID, $
       fromID:fromID, $
       toID:toID, $
       readID:readID, $
       daysID:daysID, $
       orbitsID:orbitsID, $
       scansID:scansID, $
       shotsID:shotsID, $
       messageID:messageID, $
       filestoreadID:filestoreadID, $
       daynightID:daynightID, $
       fromfolder:'', $
       tofolder:'', $
       latitudefromID:latitudefromID, $
       latitudetoID:latitudetoID, $
       stepslatID:stepslatID, $
       altitudefromID:altitudefromID, $
       altitudetoID:altitudetoID, $
       stepsaltID:stepsaltID, $
       filesptr:ptr_new(), $
       data: ptr_new() $
       }

   ; Store the info structure in the user value of the TLB.

Widget_Control, tlb, Set_UValue=info, /No_Copy

   ; Set up the event loop. Register the program with the window manager.

XManager, 'vSaber', tlb, /No_Block, Cleanup='VSaber_Cleanup'
END ;---------------------------------------------------------------------------